<?php

class actionScmobileappApiScmobileappGetsidebar extends cmsAction{

    /**
     * Блокировка прямого вызова экшена
     * обязательное свойство
     * @var boolean
     */
    public $lock_explicit_call = true;
    /**
     * Результат запроса
     * обязательное свойство
     * @var array
     */
    public $result;
    /**
     * Массив названий ячеек
     * которые нужно удалить из результирующего массива
     * необязательное свойство
     * @var array
     */
    public $unset_fields;
    /**
     * Флаг, обязующий проверять параметр sig запроса
     * sig привязан к домену сайта и к ip адресу посетителя
     * @var boolean
     */
    public $check_sig = false;
    /**
     * Возможные параметры запроса
     * с правилами валидации
     * Если запрос имеет параметры, необходимо описать их здесь
     * Правила валидации параметров задаются по аналогии с полями форм
     * @var array
     */
    public $request_params = array();
    /**
     * Необязательный метод проверки запроса
     * В нём выполняются некий действия по валидации
     * возвращает либо false в случае успешной проверки
     * либо массив данных ошибки
     */
    public function validateApiRequest() { return false; }
    /**
     * Основной метод работы экшена
     * Его задача заполнить свойство $this->result
     */
    public function run(){
       $menu = cmsCore::getModel('menu');


        $ctypes = $this->model->getCTypes();
//        print_r($ctypes);
        $page = $this->request->get('page');
        $type = $this->request->get('type');
        $auth_token = $this->request->get('auth_token');

        if (!in_array($type,array('leftmenu','rightmenu'))){
            $type = 'leftmenu';
        }

        $menu_widget = $this->model->getWidget($page,array($type));
        $menu_items = array();
        if ($menu_widget){

            $res = $this->model->getMenu($menu_widget['options']['menu'] ? $menu_widget['options']['menu'] : 'main');
            $menu_items = $menu->getMenuItems($res['id']);

            foreach ($menu_items as $key=>$item) {

                if ($item['parent_id'] !=='0' ){
                    unset($menu_items[$key]);
                    continue;
                }


                // если URL пункта меню содержит шаблон {controller:action}
                if (preg_match('/^{([a-z0-9]+):*([a-z0-9_]*)}$/i', $item['url'], $matches)){
                    $menu_items[$key]['controller'] =ucwords($matches[1]);
                    $menu_items[$key]['action'] =$matches[2];
                } else {
                    if (in_array($item['url'], $ctypes)){
                        $menu_items[$key]['controller'] ='Content';
                        $menu_items[$key]['action'] =$item['url'];
                    } else {
                        $menu_items[$key]['controller'] = ucwords($item['url']);
                    }
                }
                $menu_items[$key]['is_custom_component'] = !in_array(strtolower($menu_items[$key]['controller']), array('content', 'users','comments','auth', 'geo', 'activity'));
            }
        }

        $widgets = $this->model->getWidgets($page, array($type.'_top', $type.'_bottom'));

        $this->result['menu']   = $menu_items;
        $this->result['top']    = $widgets[$type.'_top'];
        $this->result['bottom'] = $widgets[$type.'_bottom'];
    }

}
